package IteratorTask;

/**
 * Class representing individual node in a tree.
 * */
public class Node implements Comparable<Node> {
	private int nodeID;
	private Node leftChild;
	private Node rightChild;

	public Node(int id) {
		this.nodeID = id;
		leftChild = null;
		rightChild = null;
	}

	/**
	 * @return the node ID
	 */
	public int getNodeID() {
		return nodeID;
	}

	/**
	 * @return the leftChild
	 */
	public Node getLeftChild() {
		return leftChild;
	}

	/**
	 * @param leftChild the leftChild to set
	 */
	public void setLeftChild(Node leftChild) {
		this.leftChild = leftChild;
	}

	/**
	 * @return the rightChild
	 */
	public Node getRightChild() {
		return rightChild;
	}

	/**
	 * @param rightChild the rightChild to set
	 */
	public void setRightChild(Node rightChild) {
		this.rightChild = rightChild;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		if (!(obj instanceof Node)) {
			return false;
		}

		Node other = (Node) obj;
		boolean edgesEqual = (this.nodeID == other.getNodeID());

		return edgesEqual;
	}

	@Override
	public int compareTo(Node o) {
		int c = Integer.compare(this.nodeID, o.getNodeID());
		if (c != 0) {
			return c;
		}
		return 0;
	}
	
	@Override
	public String toString() {	
		return Integer.toString(nodeID);
	}
}
