import unittest
from Tree import Tree
from Tree import Node

class IteratorTest(unittest.TestCase):
	def test_tree(self):
		t = Tree()
		
		original_nodes = []
		for i in range(1,10):
			original_nodes.append(Node(i))

		
		root = t.root
		#l1
		root.left = original_nodes[0]
		root.right = original_nodes[1]
		#l2
		root.left.left = original_nodes[2]
		root.left.right = original_nodes[3]
		root.right.left = original_nodes[4]
		root.right.right = original_nodes[5]
		#l3
		root.left.left.left = original_nodes[6]
		root.left.left.right = original_nodes[7]
		root.left.right.left = original_nodes[8]
		#root node
		original_nodes.append(Node(0))
		#sorting for evaluation
		original_nodes.sort(key=lambda x: x.nodeID)
		
		result = []
		for node in t.iterate_nodes():
			result.append(node)
		result.sort(key=lambda x: x.nodeID)
		
		
		self.assertTrue(len(original_nodes),len(result))
		self.assertListEqual(original_nodes,result)



if __name__ == '__main__':
    unittest.main()
